/**
 * i_lock.h
 * internal header
 */
#ifndef __I_LOCK_INCLUDED
#define __I_LOCK_INCLUDED

#ifdef _MSC_VER
#pragma warning(disable:4786)
#define for if(0); else for
#endif

#include <map>
#include <vector>
#include <await/lockmanager.h>

namespace await_n {

using namespace std;

//-----------------------------------------------------------------------------

enum { SHARED_LOCK = 0, EXCLUSIVE_LOCK = 1 };
typedef map<void const *, int> UnitedLockTable;
typedef map<int, UnitedLockTable> ChoiceLockTable;

class LockSlotObject {
private:
	UnitedLockTable m_mContent;
public:
	LockSlotObject();
	LockSlotObject(void const *pResource, int nLockType);
	void add(LockSlotObject const *p);
	UnitedLockTable const &getUnitedLockTable() const { return m_mContent; }
};

class LockQueryObject {
private:
	ChoiceLockTable m_mContent;
public:
	LockQueryObject();
	LockQueryObject(long, LockSlotObject *);
	void add(LockQueryObject const *p);
	ChoiceLockTable const &getChoiceLockTable() const { return m_mContent; }
};

} // namespace await_n

#endif

//=============================================================================
