/**
 * posix/i_monitor.h
 */
#ifndef __POSIX_MONITOR_INCLUDED
#define __POSIX_MONITOR_INCLUDED

#include <pthread.h>
#include <errno.h>
#include <sys/time.h>
#include <await/monitor.h>

namespace await_n {

class MonitorImpl: public Monitor {
private:
	long m_count;
	pthread_mutex_t m_mutex;
	pthread_cond_t m_cond;
public:
	MonitorImpl();
	virtual ~MonitorImpl();
	virtual void enter();
	virtual void leave();
	virtual bool sleep(AbsoluteMoment);
	virtual void awake();
};

typedef pthread_t threadid_t;

threadid_t getSelfThreadId();

} // namespace await_n

#endif
//=============================================================================
