/**
 * win32/i_monitor.h
 */
#ifndef __WIN32_MONITOR_INCLUDED
#define __WIN32_MONITOR_INCLUDED

#include <windows.h>
#include <await/monitor.h>

namespace await_n {

class MonitorImpl: public Monitor {
private:
	long m_nCount;
	HANDLE m_hMutex;
	HANDLE m_hEvent;
public:
	MonitorImpl();
	virtual ~MonitorImpl();
	virtual void enter();
	virtual void leave();
	virtual bool sleep(AbsoluteMoment);
	virtual void awake();
};

typedef DWORD threadid_t;

threadid_t getSelfThreadId();

} // namespace await_n

#endif
//=============================================================================
