/**
 * refcounter.cpp
 */
#include <memory/refcounter.h>
#include <await/await.h>

namespace memory {

RefCounter::RefCounter(): m_nRefCount(1) {
	// do nothing more
}

RefCounter::~RefCounter() {
	// do nothing
}

void RefCounter::incRefCount() {
	synch()
		++m_nRefCount;
}

void RefCounter::decRefCount() {
	long n;
	synch()
		n = --m_nRefCount;
	if(0 == n)
		delete this;
}

} // namespace memory

//=============================================================================
